﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace WebApplication11.Controllers
{
    public class StateController : Controller
    {
        // GET: State
        public ActionResult Index()
        {
            return View();
        }

        //1. Mechanizm sesji
        public ActionResult SessionTest()
        {
            if (Session["a"] != null)
            {
                ViewBag.Message = Session["a"];
            }
            else
            {
                ViewBag.Message = "Sessja pod 'a' jest pusta";
            }

            return View();
        }

        [HttpPost]
        public ActionResult SessionTest(string val)
        {
            if (!string.IsNullOrEmpty(val))
            {
                Session["a"] = val;

                return RedirectToAction("SessionTest");
            }

            return View();
        }


        //2. Mechanizm kontekstu aplikacji
        public ActionResult AppTest()
        {
            var application = HttpContext.Application;

            if (application["a"] != null)
            {
                ViewBag.Message = application["a"];
            }
            else
            {
                ViewBag.Message = "Kontekst aplikacji pod 'a' jest pusty";
            }

            return View();
        }

        [HttpPost]
        public ActionResult AppTest(string val)
        {
            var application = HttpContext.Application;

            if (!string.IsNullOrEmpty(val))
            {
                application["a"] = val;

                return RedirectToAction("AppTest");
            }

            return View();
        }


        //3. Mechanizm ciasteczek
        public ActionResult CookieTest()
        {
            if (Request.Cookies["a"] != null)
            {
                ViewBag.Message = Request.Cookies["a"].Value;
            }
            else
            {
                ViewBag.Message = "Ciasteczko 'a' nie istnieje";
            }

            return View();
        }

        [HttpPost]
        public ActionResult CookieTest(string val)
        {
            HttpCookie cookie;

            if (!string.IsNullOrEmpty(val))
            {
                cookie = new HttpCookie("a");
                cookie.Value = val;
                cookie.Expires = DateTime.Now.AddSeconds(30);

                Response.Cookies.Add(cookie);

                return RedirectToAction("CookieTest");
            }

            return View();
        }
    }
}